<?php # This is an include file

require 'functions.php';

# Find the list of the files, $re evaluated from $_SERVER['SCRIPT_NAME']
$rq = $_SERVER['SCRIPT_NAME'];
if (substr($rq, -1) == '/') $rq .= 'index.php';
$re = '/^' . substr(basename($rq), 0, -4) . '-(.*)\./';
unset($flist);
$dirhandle = opendir('.');
while ($fn = readdir($dirhandle)) {
  if (preg_match($re, $fn, $m)) {
    if (strpos($m[1], '_') === FALSE) { # ignore lang_charset
      $f = array('fn' => $fn, 'ext' => $m[1]);
      $flist[] = $f;
    }
  }
}
closedir($dirhandle);

# Get the list of acceptable languages
unset($acclang);
if ($_SERVER['HTTP_ACCEPT_LANGUAGE']) {
  $acclang = explode(',', $_SERVER['HTTP_ACCEPT_LANGUAGE']);
  for ($i = 0; $i < count($acclang);  $i++) {
    $L = explode(';', $acclang[$i]);
    $acclang[$i] = trim($L[0]);
  }
} else $acclang = array('en', 'cs');

$xlang = FindLanguage($flist, $acclang);

# Remove language variants and find a file
if ($xlang < 0) {
  for ($i = 0; $i < count($acclang);  $i++) {
    $L = explode('-', $acclang[$i]);
    $acclang[$i] = trim($L[0]);
  }
  $acclang[] = 'en'; # Add English
  $xlang = FindLanguage($flist, $acclang);
}

# Serve the first available
if ($xlang < 0) $xlang = 0;

# If no file found, display variants and exit, otherwise fill the file name
if ($xlang < 0) {
?>
<html><body>
<p>No acceptable variant was found. Your browser is set to require text in languages:
<code><?php echo $_SERVER['HTTP_ACCEPT_LANGUAGE']; ?></code>
but only the following variants are available:</p>
<ul>
<?php
  for ($i = 0;  $i < count($flist);  $i++) {
    $ext = $flist[$i]['ext'];  $f = $flist[$i]['fn'];
    reset($languages);
    while (list($k, $v) = each($languages)) {
      if ($ext == $k) {
        echo "<li><a href=\"$f\">$v</a></li>\n";  $f = false;
      }
    }
  }
?>
</ul>
<p>You can read more about <a title="Content negotiation" target="content_neg"
href="http://hroch486.icpf.cas.cz/wagner/content-negotiation.shtml.en">content negotiation</a> if
you wish to know how to setup your WWW browser correctly.</p>
<hr>
<!--WZ-REKLAMA-1.0-->
</body></html>
<?php
  exit;
}
$fn = $flist[$xlang]['fn'];
EmitHeader($fn);
$inc = preg_match('/\.php$/', $fn);
?>
