// $Id: player.js 220 2015-01-11 10:25:35Z zw $

// Old timer value
var PathTimer = -1;

// Video and map positioning
var current = 0;
var sel;
var Map;
var Pos = -1;
var vdir = '';
var seekDelay = 250;
var sliding = false;

function initplayer() {
setTimer(0);
sel = document.getElementById('currentfile');
var len = playlist.length;
var i = playlist[0].file.lastIndexOf('/');
if (i > 0) vdir = playlist[0].file.substr(0, i+1);
for (i = 0;  i < len;  i++) sel.options[i] = new Option(playlist[i].title, playlist[i].file);

// Setup the player
jwplayer("Player").setup({
  primary: 'html5',
  width: '100%',
  aspectratio: '16:9',
  playlist: playlist});

// Callback functions
jwplayer("Player").onTime(function (event) {
  SendTime(event.position);
});

jwplayer("Player").onPlay(function (event) { Playing(); });
jwplayer("Player").onPause(function (event) { NotPlaying(); });
jwplayer("Player").onComplete(function (event) { NotPlaying(); });
jwplayer("Player").onIdle(function (event) { NotPlaying(); });

jwplayer("Player").onPlaylistItem(function (event) {
  current = sel.selectedIndex = event.index;
});

jwplayer('Player').onSeek(function (event) {
  if (Pos > 0) {
    if (Pos  - event.position < 1) Pos = -1;
    else {
      setTimeout('delayedSeek()', seekDelay);
    }
  }
});

Map = parent.map; // the map frame
}// initplayer()

// Helper functions
function Playing() {
if (Map.playing !== undefined) Map.playing = Map.fixnow = true;
}

function NotPlaying() {
if (Map.playing !== undefined) Map.playing = false;
}

function SendTime(position) {
  var tm = offset[current] + position;
  if (!sliding) setTimer(tm); // do not update the displayed value while sliding
  if (Map.VideoTime !== undefined) Map.VideoTime = tm;
}

function Select(selectedIndex) {
  if (selectedIndex != current) {
    current = selectedIndex;
    jwplayer('Player').playlistItem(selectedIndex);
  }
}

function delayedSeek() {
  jwplayer('Player').seek(Pos);
}

// Going to a specific time according to a mouse click
// on the path shown on the map
function gotoTime(tm, vdx) {
  var pos = Math.round(tm - offset[vdx]);
  if (vdx != current) {
    Pos = pos;
    current = selectedIndex = vdx;
    jwplayer('Player').playlistItem(vdx);
    setTimeout('delayedSeek()', seekDelay);
  } else jwplayer('Player').seek(pos);
}

// Take a snapshot
function snapshot() {
  var file = playlist[current].title;
  var pos = jwplayer('Player').getPosition().toString().replace(/\./, '_');
  var jpg = file.replace(/\.(.*)$/, '-$1-' + pos + '.jpg');
  return 'snapshot.php/' + vdir + jpg;
}

// Update the displayed value of the slider
function updateTimer() {
  var tm = Math.floor(document.getElementById('path-timer').value);
  if (tm != PathTimer) {
    PathTimer = tm;
    var hrs = Math.floor(tm/3600);
    var min = Math.floor((tm - 3600 * hrs) / 60);
    var sec = Math.floor(tm % 60);
    var fmt = '';
    if (hrs < 10) fmt += '0';
    fmt += hrs + ':';
    if (min < 10) fmt += '0';
    fmt += min + ':';
    if (sec < 10) fmt += '0';
    fmt += sec;
    document.querySelector('#timer-position').value = fmt;
  }
}

// Change the position
function changeTimer() {
  var tm = Math.floor(document.getElementById('path-timer').value);
  jumpTo(tm);
}

// Jump to a specified time, it is neessary to find the video index
function jumpTo(tm) {
  var L = 0, U = offset.length - 1, M;
  while (L <= U) {
    M = (L + U) >> 1;
    var t = offset[M];
    if (t <= tm) L = M + 1;
    if (t >= tm) U = M - 1;
  }
  if (L - U < 2) M = U;
  gotoTime(tm, M);
}

// Set the slider value from an external source
function setTimer(val) {
  document.getElementById('path-timer').value = val;
  updateTimer();
}

// Go to the first moment when the car starts running
function run() {
if (parent.path !== undefined && parent.LastIdx !== undefined && parent.LastIdx >= 0 && Map.idx !== undefined) {
  var idx = Map.idx;
  if (idx < 0) idx = 0;
  var k, P;
  // Find the moment when the car is certainly running, protection against GPS imprecision
  for (k = idx;  k < parent.LastIdx;  k++) {
    P = parent.path[k];
    if (P.speed !== undefined && P.speed > 5) break;
  }
  // Find the latest moment of a standing car (threshold of 1 km/h used in incl_getgps.php)
  for (;  k > idx;  k--) {
    P = parent.path[k];
    if (P.speed === undefined || P.speed < 1) break;
  }
  // Fix the moment of the standing car, this period may be too long (see incl_getgps.php)
  if (k < parent.LastIdx) k++;
  var tm = parent.path[k].time - 2;
  if (k > 0) k--;
  if (tm < parent.path[k].time) tm = parent.path[k].time;
  if (tm > parent.path[idx].time) jumpTo(tm); // protect from jumping backwards
}}

// Set the sliding status
function setSliding(val) {
sliding = val;
}
